#include "hcl.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#define LONGER(x,y) (strlen(x)>strlen(y))?strlen(x):strlen(y)


int parse_list(hcentry *entry);
int control_list(hcentry *entry, unsigned long addr);
int makecontrol(char *str, hcentry *entry);
int addlist(char *str, hcentry *entry);
int printlist(hcentry *entry,int mod);
int hcl(char *nick, unsigned long addr);


int hcl(char *nick, unsigned long addr)
{
hcentry entry;
struct hostent *hent;
struct sockaddr_in saddr;
char *straddr;
int a,b,c,d;

entry.nick=malloc(strlen(nick));
strcpy(entry.nick,nick);


if(parse_list(&entry)==NOFOUND)
#ifdef DEFAULT_ACCEPT
return(OK);
#else
return(ERR);
#endif


if(entry.maxaddr<0)
#ifdef USEDEFAULT
entry.maxaddr=DEFADDR;
#else 
return(OK);
#endif

if(control_list(&entry,addr)==OK) 
{
return(OK);
}
if(entry.numaddr<entry.maxaddr)
{
saddr.sin_addr.s_addr=addr;
saddr.sin_family=AF_INET;

if(!(hent=gethostbyaddr((char *) &saddr,sizeof(saddr),AF_INET)))
{
straddr=malloc(16);
straddr=inet_ntoa(saddr.sin_addr);
sscanf(straddr,"%d.%d.%d.%d",&a,&b,&c,&d);
memset(straddr,0x0,16);
sprintf(straddr,"%d.%d.%d.*",a,b,c);
}
else
{
straddr=malloc(64);
hent->h_name=strchr(hent->h_name,'.');
strcpy(straddr,"*");
strcat(straddr,hent->h_name);
}

addlist(straddr,&entry);


return(OK);
}
return(ERR);
}

/* addlist: add the str address in entry and reprint the configuration file */

addlist(char *str,hcentry *entry)
{
if(entry->numaddr<MAXADDR)
{
entry->listaddr[entry->numaddr]=malloc(strlen(str));
strcpy(entry->listaddr[entry->numaddr],str);
entry->numaddr++;
printlist(entry,strlen(str)+1);
return(OK);
}
return(ERR);
}

/* printlist: prints the new entry on the prev one, the new one is mod
   char longer than the old one */

printlist(hcentry *entry, int mod)
{
FILE *fou;
char *line,ch;
int lng;
long fc,fe;

line=malloc(MAXLINE);

if((fou=fopen(LIST_FILE,"r+"))==NULL)
return(ERR);


while(fgets(line,MAXLINE,fou)!=NULL)
{
lng=strlen(line);
line=strtok(line,":");

if(!strncmp(line,entry->nick,LONGER(line,entry->nick)))
{
fc=ftell(fou)-1;
fseek(fou,-1L,SEEK_END);

for(fe=ftell(fou);fe>=fc;fe--)
{
ch=fgetc(fou);
fseek(fou,mod-1,SEEK_CUR);
fputc(ch,fou);
fseek(fou,fe,SEEK_SET);
}
fseek(fou,fc-lng+1,SEEK_SET);

fprintf(fou,"%s:",entry->nick);

if(entry->maxaddr>-1)   fprintf(fou,"%d",entry->maxaddr);
fprintf(fou,":");

for(lng=0;entry->listaddr[lng];lng++)
{
if(lng)  fprintf(fou,",");
fprintf(fou,"%s",entry->listaddr[lng]);
}
fprintf(fou,":%c",10);
}
}
return(OK);
}


/* control_list: compare addr with all the addresses in entry->listaddr. */

int control_list(hcentry *entry, unsigned long addr)
{
int i=0,a,b,c,d;
char *dotaddr, confstring[64];
struct hostent *hent;
struct sockaddr_in saddr;


if(!addr) return(OK);

memset(confstring,0x0,64);
saddr.sin_addr.s_addr=addr;
saddr.sin_family=AF_INET;

dotaddr=malloc(16);
dotaddr=inet_ntoa(saddr.sin_addr);

if(!makecontrol(dotaddr, entry)) return(OK);

sscanf(dotaddr,"%d.%d.%d.%d",&a,&b,&c,&d);
sprintf(confstring,"%d.%d.%d.*",a,b,c);

if(!makecontrol(confstring, entry)) return(OK);

if(!(hent=gethostbyaddr((char *) &saddr,sizeof(saddr),AF_INET))) return(ERR);

if(!makecontrol(hent->h_name, entry)) return(OK);

hent->h_name=strchr(hent->h_name,'.');
strcpy(confstring,"*");
strcat(confstring,hent->h_name);

if(!makecontrol(confstring, entry)) return(OK);
return(ERR);
}

/* makecontrol: make the effective control (a lot of strcmp) and returns OK
   if find a hit, ERR if not */

makecontrol(char *str, hcentry *entry)
{
int i;
for(i=0;entry->listaddr[i];i++)
 {if(!strcmp(entry->listaddr[i], str)) return(0);}
return(ERR);
}

/* parse_list: parse the LIST_FILE and fill up the hcentry structure.
   The function return ERR on error, NOFOUND if no entry was founded on OK 
   if at least one entry was founded */

int parse_list(hcentry *entry)
{
FILE *fin;
char *line,
     *dem,
     *nick,
     *part1,
     *num;     
   
int sd,i;

if((fin=fopen(LIST_FILE,"r"))==NULL) 
return(ERR);

memset(&entry->maxaddr,0x0,sizeof(entry->listaddr)+2*sizeof(int));

line=malloc(MAXLINE);
dem=malloc(MAXLINE);
nick=malloc(MAXNICK);
part1=malloc(MAXADDR*64);
num=malloc(2); /* hem... [log10((double) MAXADDR) + 1] seems ridicolous */


while(fgets(line,MAXLINE,fin)!=NULL)  
{
memset(nick,0x0,MAXNICK);
dem=strchr(line,':');
strncpy(nick,line,dem-line);

if(!strncmp(nick,entry->nick,LONGER(nick,entry->nick)))
{
fclose(fin);
memset(part1,0x0,MAXADDR*64);
memset(num,0x0,2);

line=strchr(++dem,':');
memcpy(num,dem,line-dem);
if(line-dem)  sscanf(num,"%d",&entry->maxaddr); else entry->maxaddr=-1;

dem=strchr(++line,':');
strncpy(part1,line,dem-line);


for(i=0;((dem=(char *)(i == 0)?strtok(part1,","):strtok(NULL,","))!=NULL);)
{
 entry->listaddr[i]=malloc(strlen(dem));
 strcpy((char *)(entry->listaddr[i]),dem);
 i++;
}
entry->numaddr=i;
return(OK);
}
}
return(NOFOUND);
}
